package org.jboss.seam.cache;

import org.jboss.seam.statistics.StatisticsGenerator;
import net.sf.ehcache.*;

/**
 * A simple wrapper around EHCache statistics
 *
 * @author Sebastian Hennebrueder
 */

public class EhCacheStatistics implements StatisticsGenerator {

  private CacheManager cacheManager;
  private String groupname = "org.jboss.seam.cache";


  public EhCacheStatistics(CacheManager cacheManager) {
    this.cacheManager = cacheManager;
  }

  public String createReport() {
    long total = 0;
    long hit = 0;
    long mis = 0;
    String[] names = cacheManager.getCacheNames();
    for (String name : names) {
      net.sf.ehcache.Cache cache = cacheManager.getCache(name);
      Statistics statistics = cache.getStatistics();
      long value = statistics.getCacheHits();
      total += value;
      hit += value;
      value = statistics.getCacheMisses();
      total += value;
      mis += value;
    }
    return String.format("EhCache statistics Total: %d Cachehits: %d (in %% %.1f) ",
            total, hit, (float) hit / total * 100);
  }

  public String getStatisticGroupname() {
    return groupname;
  }
}
